function dcm = ang2dcm(r1, r2, r3)
    % Return xyz degree cosine matrix
    angles = [r1(:) r2(:) r3(:)];

    dcm = zeros(3,3,size(angles,1));
    cang = cos( angles );
    sang = sin( angles );

    dcm(1,1,:) = cang(:,2).*cang(:,3);
    dcm(1,2,:) = sang(:,1).*sang(:,2).*cang(:,3) + cang(:,1).*sang(:,3);
    dcm(1,3,:) = -cang(:,1).*sang(:,2).*cang(:,3) + sang(:,1).*sang(:,3);
    dcm(2,1,:) = -cang(:,2).*sang(:,3);
    dcm(2,2,:) = -sang(:,1).*sang(:,2).*sang(:,3) + cang(:,1).*cang(:,3);
    dcm(2,3,:) = cang(:,1).*sang(:,2).*sang(:,3) + sang(:,1).*cang(:,3);        
    dcm(3,1,:) = sang(:,2);
    dcm(3,2,:) = -sang(:,1).*cang(:,2);
    dcm(3,3,:) = cang(:,1).*cang(:,2);
return